/* Copyright placeholder */

dg_ImageGallery = function(config){
	this.name = "Image Gallery";
	this.script = { name:"image_gallery.js", version : "1.0.12" };
	this.config = config;
	this.init(arguments[1]);
};

dg_ImageGallery.prototype = {
	d : function(id){ return document.getElementById(id); },
	genUid: function(){ return "dg_" + Math.ceil((new Date()).valueOf() * Math.random()).toString().substr(0,7) + "_dg"; },
	fetchOptions: function(){
		for(var i = 0; i < this.availableOptions.length; i++){
			this[this.availableOptions[i].name] = this.availableOptions[i].value;
			if(this.config.hasOwnProperty("options")){
				if(this.config.options.hasOwnProperty(this.availableOptions[i].name)){ this[this.availableOptions[i].name] = this.config.options[this.availableOptions[i].name]; }
			}
		}
	},
	fetchTemplates: function(){
		for(var i = 0; i < this.availableTemplates.length; i++){
			this[this.availableTemplates[i].name + "Template"] = this.availableTemplates[i].value;
			if(this.config.hasOwnProperty("templates")){
				if(this.config.templates.hasOwnProperty(this.availableTemplates[i].name)){ this[this.availableTemplates[i].name + "Template"] = this.config.templates[this.availableTemplates[i].name]; }
			}
		}
	},
	fetchCustomCSS: function(){
		for(var i = 0; i < this.availableCSS.length; i++){
			this[this.availableCSS[i] + "CSS"] = this.cssPrefix + " " + this.availableCSS[i];
			this.availableCSS[i] = "." + this.cssPrefix + "." + this.availableCSS[i];
		}
		if(this.config.hasOwnProperty("customCSS")){
			for(var i = 0; i < this.config.customCSS.length; i++){
				var defaultName = this.config.customCSS[i].split("=")[0].replace(/^\s*/,"").replace(/\s*$/,"");
				var newName = this.config.customCSS[i].split("=")[1].replace(/^\s*/,"").replace(/\s*$/,"");
				defaultName = defaultName.replace(this.cssPrefix, "").replace(/\./g,"");
				newName = newName.substr(0, 1) == "." ? newName.substr(1, newName.length) : newName;
				this[defaultName + "CSS"] = newName.replace(/\./g, " ");
			}
		}
	},
	bindToEB: function(){
		if(typeof EB == "undefined"){ EB = new Object(); }
		if(EB){
			if(!EB.hasOwnProperty("_block")){ EB._block = new Array(); }
			EB._block[EB._block.length] = this;
		}
	},
	init: function(){
		this.uid = this.genUid();
		this.container = this.d(this.config.container);
		this.availableOptions = [
			{ name: "eventNamePrefix", value: "Image_Gallery"},
			{ name: "dimensionOverride", value: "none"},
			{ name: "imageSmartLoader", value: false},
			{ name: "showImageCaption", value: true},
			{ name: "showNavigationBar", value: true},
			{ name: "showImageIndicator", value: false},
			{ name: "tiltNavigation", value: false},
			{ name: "wraparound", value: true }
		];
		this.availableTemplates = [
			{ name: "caption", value: "{IMAGE_CAPTION}"},
			{ name: "indicator", value: "&#8226;"}
		];
		this.cssPrefix = "imageGallery";
		this.availableCSS = ["galleryStage", "imageCaptionBar", "imageLoader", "leftNavigation", "rightNavigation", "indicatorBar", "indicatorOn", "indicatorOff"];
		this.config.actionRegister = undefined;

		this.fetchOptions();
		this.fetchTemplates();
		this.fetchCustomCSS();

		this.currentIndex = 0;

		//if we have wraparound enabled, then insert copies of the first and last ad into the images array for wraparound
		//MODIFICO QUI SOTTO COSI NON LO FACCIO MAI ENTRARE IN QUESTA IF, ANCHE SE MI SERVE wraparound = true. aggiungendo  && this.wraparound == 3
		if(this.wraparound && this.wraparound == 3){
			var first = this.config.images[0];
			var last = this.config.images[this.config.images.length-1];

			//make a copy of the current first ad in the images array
			var newfirst = { source:last.source, width:last.width, height:last.height, caption:last.caption, widgets:last.widgets };

			//make a cipy of the current last ad in the images array
			var newlast = {	 source:first.source, width:first.width, height:first.height, caption:first.caption, widgets:first.widgets };

			//If you had images orig1, orig2, orig3 you'll now also have copies copy1 and copy 3

			//now insert the copies into the array to help wraparound

			//insert the copy1 onto the end of the array
			this.config.images.push(newlast);

			//and insert the copy3 to the start of the array
			this.config.images.splice(0,0,newfirst);

			//now the array which had orig1, orig2 and orig3
			//would now have copy3, orig1, orig2, orig3, copy1
			//We start (with index = 1) at orig1
			//search for more wraparound code below for how it works with those copy images

			this.currentIndex = 1;		//then start at index 1 instead (which is the original first image)
		}

		this.galleryWidth = this.config.width;
		this.galleryHeight = this.config.height;
		this.tiltDir = "center";
		this.previousTiltDir = "center";
		this.tiltResetTimer = null;
		if(this.config.images.length === 1){ this.showNavigationBar = false; }
		this.isMobileDevice = (typeof clientDetector != "undefined" ? clientDetector.isMobile() : false);
		this.useTouchEvent = (typeof clientDetector != "undefined" ? (clientDetector.ios || (clientDetector.android && clientDetector.ua.indexOf("android 2") == -1)) : false);
		this.isWP75 = (typeof clientDetector != "undefined" ? clientDetector.ua.indexOf("windows phone os 7.5") != -1 : false);
		this.noSwipeSupported = this.isWP75;

		if(!this.wraparound){
			if(this.dimensionOverride == "fullscreen"){
				this.galleryWidth = document.width;
				this.galleryHeight = document.height;
			}else if(this.dimensionOverride == "images"){
				for(var i = 0; i < this.config.images.length; i++){
					this.galleryWidth = Math.max(this.galleryWidth, this.config.images[i].width);
					this.galleryHeight = Math.max(this.galleryHeight, this.config.images[i].height);
				}
			}
		}

		this.bindToEB();
		if(EB.isInitialized()){ this.buildImageGallery(); }
	},
	ebReady: function(){
		if(EB._block){
			for(var i = 0; i < EB._block.length; i ++){
				if(EB._block[i].name == "Image Gallery" && !EB._block[i].proceeded){ EB._block[i].buildImageGallery(); }
			}
		}
	},
	getImageTag : function(img){
		var thisImg = this.config.images[img];
		var code = "<div style='position:relative;top:0px;left:0px;width:100%;height:100%;z-index:0;'><table border='0' width='100%' height='100%' cellpadding='0' cellspacing='0'><tr><td align='center' valign='middle'>";
		var imgWidth = imgHeight = 0;
		if(this.dimensionOverride == "images"){
			imgWidth = thisImg.width;
			imgHeight = thisImg.height;
		}else{
			imgWidth = this.galleryWidth;
			imgHeight = this.galleryHeight;
		}
		if(thisImg.videoPlayButton){
			code += "<img draggable='false' ondragstart='return false' id='" + this.uid + "ImgImage_" + img + "' src='" + thisImg.source + "' border='0' style='width:" + imgWidth +"px;height:" + imgHeight + "px;visibility:hidden; margin-top:"+posterVideoMarginTop+"'/>";
		}else{
			code += "<img draggable='false' ondragstart='return false' id='" + this.uid + "ImgImage_" + img + "' src='" + thisImg.source + "' border='0' style='width:" + imgWidth +"px;height:" + imgHeight + "px;visibility:hidden;'/>";
		}
		code += "</td></tr></table></div>";
		var vidbut = thisImg.videoPlayButton;
		if(vidbut) {
			var buttonLeftPos = (this.galleryWidth/2) - (vidbut.width/2);
			var buttonTopPos = (this.galleryHeight/2) - (vidbut.height/2);
			code += "<div style='position:absolute;left:"+buttonLeftPos+"px;top:"+buttonTopPos+"px;display:block;z-index:2000;'>";
			code += "<img draggable='false' ondragstart='return false' width='"+vidbut.width+"' height='"+vidbut.height+"' src='" +vidbut.source+ "' onclick='"+vidbut.onclick+"' ontouchstart='"+vidbut.onclick+"' border='0'/>"
			code += "</div>";
		}
		else {
			code += "<div style='position:absolute;top:0px;left:0px;width:100%;height:100%;display:block;font-size:1000px;z-index:0;cursor:pointer;'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</div>";
		}
		code += "<div id='" + this.uid + "ImgCaption_" + img + "' style='max-width:" + this.galleryWidth +"px;display:none;' class='" + this.imageCaptionBarCSS + "'>" + this.captionTemplate.replace(/{IMAGE_CAPTION}/g, (thisImg.caption ? thisImg.caption : "")) + "</div>";

		return code;
	},
	getAdjustedImageDimension : function(imageObj){
		var originalWidth = imageObj.naturalWidth;
		var originalHeight = imageObj.naturalHeight;
		var imageWidth = this.galleryWidth;
		var imageHeight = this.galleryHeight;
		if(this.dimensionOverride != "fullscreen" && (originalWidth <= this.galleryWidth && originalHeight <= this.galleryHeight)){
			imageWidth = originalWidth;
			imageHeight = originalHeight;
		}else{
			if(this.galleryWidth > this.galleryHeight){
				if(originalWidth >= originalHeight){
					imageHeight = originalHeight * (this.galleryWidth / originalWidth);
				}else{
					imageWidth = originalWidth * (this.galleryHeight / originalHeight);
				}
			}else{
				if(originalWidth >= originalHeight){
					imageHeight = originalHeight * (this.galleryWidth / originalWidth);
				}else{
					imageWidth = originalWidth * (this.galleryHeight / originalHeight);
				}
			}
			if(imageWidth > this.galleryWidth){
				imageWidth = this.galleryWidth;
				imageHeight = originalHeight * (this.galleryWidth / originalWidth);
			}
			if(imageHeight > this.galleryHeight){
				imageHeight = this.galleryHeight;
				imageWidth = originalWidth * (this.galleryHeight / originalHeight);
			}
		}
		return [Math.ceil(imageWidth), Math.ceil(imageHeight)];
	},
	imageLoaderSub : function(){
		for(var i = 0; i < EB._block.length; i++){
			if(this.id.split("ImgImage_")[0] == EB._block[i].uid){
				var imgId = this.id.split("ImgImage_")[1];
				var ig = EB._block[i];
				if(!ig.config.images[imgId].loaded){
					var imgSlot = ig.d(ig.uid + "ImgSlot_" + imgId);
					var imgObject = ig.d(ig.uid + "ImgImage_" + imgId);
					if(ig.dimensionOverride != "images"){
						var imageDimension = ig.getAdjustedImageDimension(imgObject);
						imgObject.style.width = imageDimension[0] + "px";
						imgObject.style.height = imageDimension[1] + "px";
					}
					imgSlot.style.backgroundImage = "none";
					if(ig.config.images[imgId].hasOwnProperty("bgColor")){ imgSlot.style.backgroundColor = ig.config.images[imgId].bgColor; }
					imgObject.style.visibility = "visible";
					if(ig.config.images[imgId].hasOwnProperty("widgets")){
						for(var j = 0; j < ig.config.images[imgId].widgets.length; j++){ 
							ig["Image" + imgId].addWidget(ig.config.images[imgId].widgets[j]); 
						}
					}
					ig.config.images[imgId].loaded = true;
					if(typeof ig.config.images[imgId].videoIdx != "undefined") { //if this is a video item
						loadVideo(ig.config.images[imgId].videoIdx, imgSlot);
					}
				}
			}
		}
		
	},
	imageLoader : function(img){
		this.d(this.uid + "ImgImage_" + img).addEventListener("load", this.imageLoaderSub, false);
	},
	buildImageGallery : function(){
		this.proceeded = true;
		this.container.innerHTML = "";
		var _wrapper = document.createElement("div");
		_wrapper.id = this.uid + "ImageGallery";
		_wrapper.style.width = this.galleryWidth + "px";
		_wrapper.style.height = this.galleryHeight + "px";
		_wrapper.style.position = "relative";
		_wrapper.style.overflow = "hidden";
		this.container.appendChild(_wrapper);

		var _masker = document.createElement("div");
		_masker.id = this.uid + "ImageGallerySub";
		_masker.className = this.galleryStageCSS;
		_masker.style.width = this.galleryWidth + "px";
		_masker.style.height = this.galleryHeight + "px";
		_masker.style.overflow = "hidden";
		_wrapper.appendChild(_masker);

		var _swiper = document.createElement("div");
		_swiper.id = this.uid + "GalleryContainer";
		//TO DO MODIFICATO e IMPOSTO LA LUNGHEZZA DELLA GALLERY AL DIV FAKE CHE MI SERVE PER SIMULARE GLI SPOSTAMENTI
		//_swiper.style.width = (this.galleryWidth * this.config.images.length) + "px";
		_swiper.style.width = "300px";
		document.getElementById("invisible_fake").style.width = (this.galleryWidth * this.config.images.length) + "px";
		
		_swiper.style.height = this.galleryHeight + "px";
		_swiper.style.position = "relative";
		_masker.appendChild(_swiper);

		var _indicator = document.createElement("div");
		_indicator.id = this.uid + "ImgIndocator";
		_indicator.className = this.indicatorBarCSS;
		_indicator.style.display = this.showImageIndicator ? "block" : "none";
		_wrapper.appendChild(_indicator);

		var _leftNav = document.createElement("div");
		_leftNav.id = this.uid + "NaviLeft";
		_leftNav.className = this.leftNavigationCSS;
		_leftNav.style.display = this.wraparound ? "block": "none";
		_wrapper.appendChild(_leftNav);

		var _rightNav = document.createElement("div");
		_rightNav.id = this.uid + "NaviRight";
		if(this.config.images.length === 1 && !this.wraparound){
			_rightNav.style.display = this.noSwipeSupported || this.showNavigationBar ? "block" : "none";
		}
		_rightNav.className = this.rightNavigationCSS;
		_wrapper.appendChild(_rightNav);

		_leftNav.addEventListener("click", function(e){
			dg_ImageGallery.prototype.stepToStop(e, 1);
			stopMyAutoSlideInterval();
			showHandAnimation = false;
		},false);
		_rightNav.addEventListener("click", function(e){
			dg_ImageGallery.prototype.stepToStop(e, -1);
			stopMyAutoSlideInterval();
			showHandAnimation = false;
		},false);

		this.swipeNavigator = new VwSwipeNavigator(_masker, _swiper, 0 - (this.galleryWidth * (this.config.images.length + 1)), 0, this.galleryWidth, 0);
		this.swipeNavigator.endTransition = "snap";

		for(var i = 0; i < this.config.images.length; i++){
			/*
var _slot = document.createElement("div");
			_slot.id = this.uid + "ImgSlot_" + i;
			_slot.style.width = this.galleryWidth + "px";
			_slot.style.height = this.galleryHeight + "px";
			_slot.style.display = "inline-block";
			_slot.style.position = "relative";
			_slot.style.overflow = "hidden";
			_slot.className = this.imageLoaderCSS;
			_swiper.appendChild(_slot);
*/

			var _slot = document.createElement("div");
			_slot.id = this.uid + "ImgSlot_" + i;
			_slot.style.width = this.galleryWidth + "px";
			_slot.style.height = this.galleryHeight + "px";
			_slot.style.display = "block";
			_slot.style.position = "absolute";
			_slot.style.top = "0px";
			_slot.style.left = "0px";
			_slot.style.overflow = "hidden";
			_slot.className = this.imageLoaderCSS;
			_swiper.appendChild(_slot);

			this["Image" + i] = _slot;
			this["Image" + i].addWidget = function(widget){
				if(widget.hasOwnProperty("name") && widget.hasOwnProperty("content")){
					for(var j = 0; j < EB._block.length; j++){
						if(this.id.split("ImgSlot_")[0] == EB._block[j].uid){
							var imgId = this.id.split("ImgSlot_")[1];
							var ig = EB._block[j];
							//window[widget.name] = ig.addWidget(imgId, ig.useTouchEvent ? widget.content.replace(/onClick/ig, "onTouchStart") : widget.content);
							
							window[widget.name] = ig.addWidget(imgId, ig.useTouchEvent ? widget.content : widget.content);
						}
					}
				}
			};

			this.config.images[i].loaded = false;
			if((this.imageSmartLoader && i < 2) || !this.imageSmartLoader){
				_slot.innerHTML += this.getImageTag(i);
				if(this.showImageCaption){ this.d(this.uid + "ImgCaption_" + i).style.display = "block"; }
				this.imageLoader(i);
			}
			this.swipeNavigator.addStop((0 - (this.galleryWidth * i)), 0);

			//if wraparound, suppress indicator for first and last images (they shouldn't count, they're only clones for smooth wraparound effect)
			var suppressIndicator = !!(this.wraparound && (i == 0 || i == this.config.images.length-1));

			//this line will now use this.currentIndex instead of a hard-coded zero so it can account for wraparound, which has currentIndex set to 1
			//it is also channged to allow for complete suppression of indicator, because the fake/clone images shouldn't get one
			if(this.showImageIndicator && !suppressIndicator){_indicator.innerHTML += "<span id='" + this.uid + "ImgInd_" + i + "' class='" + (i === this.currentIndex ? this.indicatorOnCSS : this.indicatorOffCSS) + "'>" + this.indicatorTemplate + "</span>";}
			
		}		
		
		if(this.dimensionOverride == "fullscreen"){
			this.resize();
			window.addEventListener('resize', dg_ImageGallery.prototype.resize, false);
			if(clientDetector.ua.toLowerCase().indexOf("android 2") != -1){
				setInterval(dg_ImageGallery.prototype.resize, 50);
			}
		}
		else if(this.wraparound) { //QUI ENTRA SOLO SE HO SETTATO LA VARIABILE PER IL LOOP
			//_swiper.style.left = (this.swipeNavigator.positionOnXAxis = 0-this.galleryWidth) + "px";
		}

		this.swipeNavigator.onNavigationComplete = function(e){
			for(var i = 0; i < EB._block.length; i++){
				if(e.target.content.id.replace("GalleryContainer","") == EB._block[i].uid){
					var ig = EB._block[i];
					if(e.axis == "x"){
						var thisIdx = e.length - 1 - e.index;

						//This block of code handles the magic wraparound, where you swiped beyond the end of the normal images, and
						//swiped to a fake/clone/copy image. As soon as the tween/navigation to that image completes, we intercept it
						//here and sneakily jump from the clone image to the actual image. So if you originally defined orig1, orig2, orig3
						//your images array would contain copy3, orig1, orig2, orig3, copy1 allowing you to swipe from orig3 to what
						//looks like orig1 but is actually copy1. As soon as the navigation to copy1 is complete, this code here catches
						//it and transparently adjusts from copy1 to orig1 (you won't see it happen), and then it fudges the thisIdx to
						//the copy1 index number and lets the tracking report the correct number.
						
						//TO DO - QUI DEVO SIMULARE IN MODO CHE IL VALORE ig.currentIndex VENGA SEMPRE AGGIORNATO ANCHE QUANDO VADO OLTRE IL PRIMO LOOP
						
						if(!ig.wraparound) {
							var rap = false;
							if(thisIdx == ig.config.images.length-1){		//if we swiped to the last image (which is a fake first image)
								rap = thisIdx = 1;							//then go to the real first image to give a seamless wraparound effect
							}
							else if(thisIdx ==0){							//else if we swiped to the first image (which is a fake last image)
								rap = thisIdx = ig.config.images.length-2;	//then go to the real last image to give a seamless wraparound effect
							}
							//if rap now points to either the first or last image, it's time to jump to/adjust offset to that image
							if(rap) {
								//do the step/stop inverting game
								var step = ig.currentIndex >= rap ? ig.currentIndex - rap : 0 - (rap - ig.currentIndex);
								var stop = ig.config.images.length - 1 - ig.currentIndex + step;
								stop = (stop < 0 ? 0 : ((stop > ig.config.images.length - 1) ? ig.config.images.length - 1 : stop));
								//now after that fun, we know which x position we need to get to snap immediately and invisibly to that point
								//this.content.style.left = (this.positionOnXAxis = this.xStops[stop]) +"px";
							}
							//So that's what the rap value was for, jumping to the right position. Notice we also updated thisIdx so
							//that the existing code below will know that we're now on the proper position for that image and it can
							//update the dot indicators and everything else. We'll also track that we swiped to that position
						}

						//if(thisIdx != ig.currentIndex){
							//var reportIdx = ig.wraparound ? thisIdx-1 : thisIdx;
							
							var _mostraSlideNum = this.slideCounter % numeroSlides;
							
							if(!EB._isLocalMode){
								EB.userActionCounter(ig.eventNamePrefix + "_Navigated_To_" + _mostraSlideNum);
							}else{
								console.log(ig.eventNamePrefix + "_Navigated_To_" + _mostraSlideNum);
							}
							
						//}
						ig.currentIndex = _mostraSlideNum;
						
						showFingerAnimation(ig.currentIndex);
						
						if(ig.showImageIndicator){
							//when wraparound enabled, don't show any indicator for first/last images
							var iStart = ig.wraparound ? 1:0;
							var iEnd = ig.wraparound ? ig.config.images.length-1:ig.config.images.length;
							for(var i = iStart; i < iEnd; i++){
								ig.d(ig.uid + "ImgInd_" + i).className = (i == ig.currentIndex ? ig.indicatorOnCSS : ig.indicatorOffCSS);
							}
						}
						
						for(var i = (ig.currentIndex == 0 ? ig.currentIndex + 1 : ig.currentIndex - 1); i < (ig.currentIndex + 2 < ig.config.images.length ? ig.currentIndex + 2 : ig.config.images.length); i++){
							if(!ig.config.images[i].loaded){
								ig.d(ig.uid + "ImgSlot_" + i).innerHTML += ig.getImageTag(i);
								if(ig.showImageCaption){ ig.d(ig.uid + "ImgCaption_" + i).style.display = "block"; }
								ig.imageLoader(i);
							}
						}
					}
				}
			}
		};
		if(window.DeviceOrientationEvent){
			window.addEventListener('deviceorientation', function(eventData){
				var tiltLR = eventData.gamma;
				var tiltFB = eventData.beta;
				var ig = EB._block;
				for(var i = 0; i < ig.length; i++){
					if(ig[i].tiltNavigation){
						var tiltValue = Math.abs(window.orientation) != 90 ? tiltLR : tiltFB;
						var sensitivity = Math.abs(window.orientation) != 90 ? 15 : 10;
						ig[i].tiltDir = tiltValue > sensitivity ? "right" : tiltValue < 0 - sensitivity ? "left" : "center";
						if(ig[i].tiltDir == "center" && ig[i].tiltResetTimer){ clearTimer(ig[i].tiltResetTimer); }
						if(ig[i].tiltDir != ig[i].previousTiltDir){
							if(ig[i].tiltDir == "left"){ ig[i].goToNextImage(); }
							if(ig[i].tiltDir == "right"){ ig[i].goToPreviousImage(); }
							ig[i].previousTiltDir = ig[i].tiltDir;
							xyz = ig[i];
							ig[i].tiltResetTimer = setTimeout(function(){
								var ig = EB._block;
								for(var i = 0; i < ig.length; i++){ ig[i].previousTiltDir = "center"; }
							}, 1500);
						}
					}
				}
			}, false);
		}
	},
	getCurrentIndex : function(){
		return this.currentIndex;
	},
	getCurrentImage : function(){
		return this.config.images[this.currentIndex];
	},
	showNavigation : function(){
		this.d(this.uid + "NaviLeft").style.visibility = "visible";
		this.d(this.uid + "NaviRight").style.visibility = "visible";
	},
	hideNavigation : function(){
		this.d(this.uid + "NaviLeft").style.visibility = "hidden";
		this.d(this.uid + "NaviRight").style.visibility = "hidden";
	},
	showIndicator : function(){
		this.d(this.uid + "ImgIndocator").style.visibility = "visible";
	},
	hideIndicator : function(){
		this.d(this.uid + "ImgIndocator").style.visibility = "hidden";
	},
	showCaption : function(){
		for(var i = 0; i < this.config.images.length; i++){
			if(this.d(this.uid + "ImgCaption_" + i)){ this.d(this.uid + "ImgCaption_" + i).style.visibility = "visible"; }
		}
	},
	hideCaption : function(){
		for(var i = 0; i < this.config.images.length; i++){
			if(this.d(this.uid + "ImgCaption_" + i)){ this.d(this.uid + "ImgCaption_" + i).style.visibility = "hidden"; }
		}
	},
	_stepToStop : function(step){		
		var _stop = this.config.images.length - 1 - this.currentIndex + step;
		_stop = (_stop < 0 ? 0 : ((_stop > this.config.images.length - 1) ? this.config.images.length - 1 : _stop));
		var leftOrRight;
		if(step == -1){
			leftOrRight = "right";
		}else{
			leftOrRight = "left";
		}
		this.swipeNavigator.navigateToStop(_stop, "x", leftOrRight);
	},
	goToNextImage : function(){
		this._stepToStop(-1);
	},
	goToPreviousImage : function(){
		this._stepToStop(1);
	},
	goToImage : function(idx){
		var step = this.currentIndex >= idx ? this.currentIndex - idx : 0 - (idx - this.currentIndex);
		if(step !== 0){ this._stepToStop(step); }
	},
	stepToStop : function(obj, step){
		for(var i = 0; i < EB._block.length; i++){
			if(obj.target.id.split("Nav")[0] == EB._block[i].uid){ EB._block[i]._stepToStop(step); }
		}
	},
	enableTiltNavigation : function(){
		this.tiltNavigation = true;
	},
	disableTiltNavigation : function(){
		this.tiltNavigation = false;
	},
	clickThrough : function(){
		var clickThruName = this.eventNamePrefix + "_ClickThrough_" + (this.currentIndex + (this.wraparound ? -1 : 0));
		if(EB._isLocalMode){
			console.log(clickThruName);
			console.log("Click through does not work in local mode");
		}else{
			if(EB._adConfig.interactions.hasOwnProperty(clickThruName)){
				var clickThruObject = EB._adConfig.interactions[clickThruName];
				EB.clickthrough(clickThruName);
			}
		}
	},
	addWidget : function(img, widget){
		var parent = this.d(this.uid + "ImgSlot_" + img);
		parent.innerHTML += widget;
		widget = parent.lastChild;
		if(!widget.id){ widget.id = img + "Widget" }
		
		//START PARTE HAMMERJS
		//myElement = document.getElementById(j+"Widget");
		myElement = widget;
		var hammertime = new Hammer(myElement);
		PreventGhostClick(myElement);
		
		var finger = document.createElement("div");
		finger.innerHTML = "<img src='images/finger.png' />";
		finger.id = "Finger"+img;
		finger.className = "finger";
		widget.appendChild(finger);
		
		TweenMax.set(finger,{alpha:0});
		
		hammertime.on('panleft', function(ev) {
			console.log(ev);
			myImageGallery._stepToStop(-1);
			stopMyAutoSlideInterval();	
			showHandAnimation = false;				
		});
		hammertime.on('panright', function(ev) {
			console.log(ev);
			myImageGallery._stepToStop(1);
			stopMyAutoSlideInterval();
			showHandAnimation = false;
			//PreventGhostClick(myElement);
		});
		hammertime.on('tap', function(ev) {
			//EB.clickthrough();
			myImageGallery.clickThrough();
		});
		
		
		if(img == 0){
			TweenMax.set(document.getElementById(this.uid + "ImgSlot_" + img),{rotationY:0,transformPerspective:200, transformOrigin:"50% 50% -150px"});
		}
		if(img == 1){
			TweenMax.set(document.getElementById(this.uid + "ImgSlot_" + img),{rotationY:90,opacity:0,transformPerspective:200, transformOrigin:"50% 50% -150px"});
		}
		if(img == 2){
			TweenMax.set(document.getElementById(this.uid + "ImgSlot_" + img),{rotationY:180,opacity:0,transformPerspective:200, transformOrigin:"50% 50% -150px"});
		}
		if(img == 3){
			TweenMax.set(document.getElementById(this.uid + "ImgSlot_" + img),{rotationY:270,opacity:0,transformPerspective:200, transformOrigin:"50% 50% -150px"});
		}
		
		
		//END PARTE HAMMERJS
		
		if(img == 0)
		showFingerAnimation(0, true);
		
		return {
			parent: parent,
			widget: widget,
			getId: function(){ return this.widget.id; },
			show: function(){ this.widget.style.display = ""; },
			hide: function(){ this.widget.style.display = "none"; },
			moveTo: function(x, y){ this.widget.style.top = y + "px"; this.widget.style.left = x + "px"; },
			remove: function(){ this.parent.removeChild(this.widget); }

		};
	},
	refresh : function(){
		this.buildImageGallery();
	},
	resize : function(width, height, force){
		var forceResize = arguments.length && force;
		var toWidth = arguments.length >= 2 ? width : window.innerWidth;
		var toHeight = arguments.length >= 2 ? height : window.innerHeight;
		var igAry = new Array();
		igAry[igAry.length] = this;
		if(typeof this.buildImageGallery != "function"){
			igAry.length = 0;
			for(var i = 0; i < EB._block.length; i++){
				if(EB._block[i].dimensionOverride == "fullscreen"){ igAry[igAry.length] = EB._block[i]; }
			}
		}
		for(var i = 0; i < igAry.length; i++){
			if(igAry[i].galleryWidth == toWidth && igAry[i].galleryHeight == toHeight && !forceResize){ return false; }
			igAry[i].galleryWidth = toWidth;
			igAry[i].galleryHeight = toHeight;
			var galleryObj = igAry[i].d(igAry[i].uid + "ImageGallery");
			var galleryStage = igAry[i].d(igAry[i].uid + "ImageGallerySub");
			var gallerySwiper = igAry[i].d(igAry[i].uid + "GalleryContainer");
			galleryObj.style.width = igAry[i].galleryWidth + "px";
			galleryObj.style.height = igAry[i].galleryHeight + "px";
			galleryStage.style.width = igAry[i].galleryWidth + "px";
			galleryStage.style.height = igAry[i].galleryHeight + "px";
			gallerySwiper.style.width = (igAry[i].config.images.length * igAry[i].galleryWidth) + "px";
			gallerySwiper.style.height = igAry[i].galleryHeight + "px";

			igAry[i].swipeNavigator.clearStops();
			igAry[i].swipeNavigator.minX = 0 - (igAry[i].config.images.length * igAry[i].galleryWidth);
			igAry[i].swipeNavigator.maxX = igAry[i].galleryWidth;
			igAry[i].swipeNavigator.positionOnXAxis = (0 - (igAry[i].currentIndex * igAry[i].galleryWidth));

			for(var j = 0; j < igAry[i].config.images.length; j++){
				var imageSlot = igAry[i].d(igAry[i].uid + "ImgSlot_" + j);
				igAry[i].swipeNavigator.addStop(0 - (igAry[i].galleryWidth * j), 0);
				imageSlot.style.width = igAry[i].galleryWidth + "px";
				imageSlot.style.height = igAry[i].galleryHeight + "px";
				if(igAry[i].d(igAry[i].uid + "ImgImage_" + j)){
					var imgObject = igAry[i].d(igAry[i].uid + "ImgImage_" + j);
					var imageDimension = igAry[i].getAdjustedImageDimension(imgObject);
					imgObject.style.width = imageDimension[0] + "px";
					imgObject.style.height = imageDimension[1] + "px";
					igAry[i].d(igAry[i].uid + "ImgCaption_" + j).style.maxWidth = igAry[i].galleryWidth + "px";
				}
			}
			gallerySwiper.style.left = (0 - (igAry[i].currentIndex * igAry[i].galleryWidth)) + "px";
		}
	}
};

document.addEventListener("DOMContentLoaded", function(){
	if(!EB.isInitialized()){
		EB.addEventListener(EBG.EventName.EB_INITIALIZED, dg_ImageGallery.prototype.ebReady);
	}
	else{
		dg_ImageGallery.prototype.ebReady();
	}
}, false);