/*-Dependencies
	MMClientDetector
*/

if (!VwTrackedObjectCount) {
    var VwTrackedObjectCount = 0;
}
function VwTouchArea(_target) {
     if (!Array.indexOf) {
        Array.prototype.indexOf = function(obj) {
            for (var i = 0; i < this.length; i++) {
                if (this[i] == obj) {
                    return i;
                }
            }
            return - 1;
        }
    }
    this.target = _target;
    this.target.style.msTouchAction = "none";
    this._isEnabled = false;
    this.enableInput();
    this.mouseIsDown = this.isActive = false;
    this.startPositionOnXAxis = null;
    this.startPositionOnYAxis = null;
    this.startTime = new Date();
    this.timeout = 2000;
    this._listeners = new Array();
    this._disabledListeners = new Array();
    this.iemousedown = null;
    this.iemousemove = null;
    this.iemouseup = null;
    this.autoEndTimeout = null;
    this.clickData = {
        startTime: null,
        startPos: {
            x: 0,
            y: 0
        },
        endPos: {
            x: 0,
            y: 0
        },
        threshold: 3,
        timeout: 300
    };
	this.directionTrend = "horizontal";
};

VwTouchArea.prototype.handleEvent = function(e, self)
{
     if (!e)
        e = window.e;
     if (!self)
        self = this;
    var evtName = convertPointerEventToTouch(e.type);

    switch (evtName)
        {
            case "touchstart":
                self.onTouchStart(e);
                break;
            case "touchmove":
                self.onTouchMove(e);
                break;
            case "touchend":
                self.onTouchEnd(e);
                break;
            case "mouseout":
                var from = e.relatedTarget || e.toElement;
                 if (!from || from.nodeName == "HTML") {
                    self.onTouchEnd(e);

                }
                break;

        }
};
VwTouchArea.prototype.processEvent = function(e) {
     if (!clientDetector.isIE()) {
        e.preventDefault();

    }
    else {
         if (event != null) {
            event.returnValue = false;

        };

    };
    return(e);

};
VwTouchArea.prototype.disableInput = function() {
     if (this._isEnabled) {
        this.removeTouchListener(this.target, "touchstart", false);
        this._disabledListeners = this._listeners;
        this._listeners = [];
        this._isEnabled = false;

    };

}
VwTouchArea.prototype.enableInput = function() {
     if (!this._isEnabled) {
        this.addTouchListener(this.target, "touchstart", false);
        this._listeners = this._disabledListeners;
        this._isEnabled = true;

    };

}
VwTouchArea.prototype.onTouchStart = function(e)
{
	this.directionTrend = "horizontal";
    window.clearTimeout(this.autoEndTimeout);
    this.isActive = true;
//    e = this.processEvent(e);
	
     if (clientDetector.supportsTouch()) {
	     if(e.targetTouches != null){
	       if (e.targetTouches.length != 1 && VwTrackedObjectCount > 0) {
            	return false;
            }
        }else{
	        return false;
        }
        VwTrackedObjectCount++;

    }
    else {
        this.mouseIsDown = true;

    };
    this.lastPointerPosition = this.currentPointerPostion = _pointerPosition = getPointerPosition(e);
    this.startPositionOnXAxis = this.clickData.startPos.x = this.clickData.endPos.x = _pointerPosition.x;
    this.startPositionOnYAxis = this.clickData.startPos.y = this.clickData.endPos.y = _pointerPosition.y;
    this.startTime = new Date();
    this.clickData.startTime = new Date();
    this.registerTouches();
    this.broadcastMessage("touchStart", {
        target: this,
        type: 'touchStart',
        touchX: this.startPositionOnXAxis,
        touchY: this.startPositionOnYAxis,
        time: this.startTime.getTime()
    });
    return false;

};

VwTouchArea.prototype.onTouchMove = function(e)
{
    window.clearTimeout(this.autoEndTimeout);
     if (clientDetector.supportsTouch() || this.mouseIsDown) {
//        e = this.processEvent(e);		//this is now too early to be stopping the bubbling
        var _newPointerPosition = getPointerPosition(e);
        var _windowLeft = window.screenX;
        var _windowTop = window.screenY;
        var _windowRight = window.screenX + window.innerWidth;
        var _windowBottom = window.screenY + window.innerHeight;
        var _xPositionOffset = _newPointerPosition.x - this.startPositionOnXAxis;
        var _yPositionOffset = _newPointerPosition.y - this.startPositionOnYAxis;

		//detect whether we're swiping mostly vertical or mostly horizontal
		var xTrend = Math.abs(_xPositionOffset);
		var yTrend = Math.abs(_yPositionOffset);
		if(yTrend > xTrend) {					//if we're swiping more vertically than horizontally
			this.directionTrend = "vertical";	//then we let it bubble up
		}										//NOTE: if you try and do this on an individual touchmove event basis, it doesn't work !!
												//		you have to detect (on the *FIRST* move event) what the trend is, and stick with
												//		that decision for the entire touchstart/move/end period.

		if(this.directionTrend == "horizontal") {	//keep all events to ourself if we're scrolling horizontally
			e = this.processEvent(e);				//this cancel bubble/prevent default moved a bit further down than where it used to be
		}

         if (clientDetector.supportsTouch()) {
             if (e.targetTouches.length != 1) {
                return false;
            };

        }
        var self = this;
        this.autoEndTimeout = window.setTimeout(function() {
            self.onTouchEnd(e);
        },
        this.timeout);
        var _newTime = new Date();
        var _timeOffset = parseInt(_newTime.getTime()) - parseInt(this.startTime.getTime());
        this.broadcastMessage("touchMove", {
            target: this,
            type: 'touchMove',
            touchX: _newPointerPosition.x,
            touchY: _newPointerPosition.y,
            xOffset: _xPositionOffset,
            yOffset: _yPositionOffset,
            time: _newTime.getTime()
        });
        this.startPositionOnXAxis = this.clickData.endPos.x = _newPointerPosition.x;
        this.startPositionOnYAxis = this.clickData.endPos.y = _newPointerPosition.y;
        this.startTime = _newTime;
        return false;

    };

};
VwTouchArea.prototype.onTouchEnd = function(e)
{
	this.directionTrend = "horizontal";
    window.clearTimeout(this.autoEndTimeout);
    this.isActive = false;
    this.broadcastMessage("touchEnd", {
        target: this,
        type: 'touchEnd'
    });
//    e = this.processEvent(e);
     if (clientDetector.supportsTouch()) {
		try{
         if (e.targetTouches.length > 0)
            {
                this.resetToTouch(e.targetTouches[0]);

            };
		}catch(e){}
    }
    else {
        this.mouseIsDown = false;

    };
    var endTime = new Date();
    var elapsedTime = parseInt(this.clickData.startTime.getTime()) - parseInt(endTime.getTime());
    var totalXOffset = Math.abs(this.clickData.startPos.x - this.clickData.endPos.x);
    var totalYOffset = Math.abs(this.clickData.startPos.y - this.clickData.endPos.y);
     if (Math.max(totalXOffset, totalYOffset) <= this.clickData.threshold && elapsedTime < this.clickData.timeout) {
        this.broadcastMessage("touchClick", {
            target: this,
            type: 'touchClick'
        });

    }
    this.unregisterTouches();
    return false;

};

VwTouchArea.prototype.resetToTouch = function(aTouch)
{
    this.startPositionOnXAxis = aTouch.clientX;
    this.startPositionOnYAxis = aTouch.clientY;

};

VwTouchArea.prototype.registerTouches = function()
{
    this.addTouchListener(window, "touchmove", false);
    this.addTouchListener(window, "touchend", false);
    this.addTouchListener(document, "mouseout", false);

};

VwTouchArea.prototype.unregisterTouches = function()
{
    this.removeTouchListener(window, "touchmove", false);
    this.removeTouchListener(window, "touchend", false);
    this.removeTouchListener(document, "mouseout", false);

};
VwTouchArea.prototype.addTouchListener = function(_target, _type, _bubbles) {
    var _touchArea = this;
     if (!_bubbles) {
        _bubbles = false
    };
    _type = window.getEquivalentDeviceInputFromTouch(_type);
     if (!clientDetector.isIE() || clientDetector.isIE9plus()) {
        _target.addEventListener(_type, _touchArea, _bubbles);

    }
    else {
         if (_target == window) {
            _target = document.body
        };
        this["ie" + _type] = function() {
            _touchArea.handleEvent(window.event, _touchArea)
        };
        _target.attachEvent("on" + _type, this["ie" + _type]);

    };

};
VwTouchArea.prototype.removeTouchListener = function(_target, _type, _bubbles) {
    var _touchArea = this;
     if (!_bubbles) {
        _bubbles = false
    };
    _type = window.getEquivalentDeviceInputFromTouch(_type);
     if (!clientDetector.isIE() || clientDetector.isIE9plus()) {
        _target.removeEventListener(_type, _touchArea, _bubbles);

    }
    else {
         if (_target == window) {
            _target = document.body
        };
        _target.detachEvent("on" + _type, this["ie" + _type]);

    };

};

VwTouchArea.prototype.addListener = function(o) {
    this.removeListener(o);
    return this._listeners.push(o);

};

VwTouchArea.prototype.removeListener = function(o) {
    var a = this._listeners;
    var i = a.length;
     while (i--) {
         if (a[i] == o) {
            a.splice(i, 1);
            return true;

        };

    };
    return false;

};

VwTouchArea.prototype.broadcastMessage = function() {
    var arr = new Array();
     for (var i = 0; i < arguments.length; i++) {
        arr.push(arguments[i])
    }
    var e = arr.shift();
    var a = this._listeners;
    var l = a.length;
     for (var i = 0; i < l; i++) {
         if (a[i][e])
            a[i][e].apply(a[i], arr);

    };

};

